{ -------------------------------------------------------------------------- }
{ BigIni demo							eh2000-07-23 }
{ -------------------------------------------------------------------------- }
unit udemo;

interface

uses
  Messages, SysUtils, classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Windows,
  BigIni;

type

  TForm1 = class(TForm)
    Memo1: TMemo;
    ButtonDemo: TButton;
    Memo2: TMemo;
    CheckBoxDropCommentLines: TCheckBox;
    CheckBoxFilterOutInvalid: TCheckBox;
    CheckBoxDropWhiteSpace: TCheckBox;
    CheckBoxDropApostrophes: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    ButtonFontTest: TButton;
    LabelFontDemo1: TLabel;
    FontDialog1: TFontDialog;
    LabelFontDemo2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ButtonDemoClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonFontTestClick(Sender: TObject);
  private
    BigIniFile : TBiggerIniFile;
    FFileName  : string;
  public
    { none }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  FFileName  := ExtractFilePath(Application.ExeName)+'demo.ini';
  BigIniFile := TBiggerIniFile.Create(''); { no filename now }
  with BigIniFile do
  begin
    CheckBoxDropCommentLines.Checked := FlagDropCommentLines;
    CheckBoxFilterOutInvalid.Checked := FlagFilterOutInvalid;
    CheckBoxDropWhiteSpace.Checked   := FlagDropWhiteSpace;
    CheckBoxDropApostrophes.Checked  := FlagDropApostrophes;
  end;
end;

procedure TForm1.ButtonDemoClick(Sender: TObject);
begin
  { save Lines to disk (again) to get test data: }
  Memo1.Lines.SaveToFile(FFileName);

  with BigIniFile do
  begin
    FlagDropCommentLines := CheckBoxDropCommentLines.Checked;
    FlagFilterOutInvalid := CheckBoxFilterOutInvalid.Checked;
    FlagDropWhiteSpace   := CheckBoxDropWhiteSpace.Checked;
    FlagDropApostrophes  := CheckBoxDropApostrophes.Checked;

    { load file: }
    FileName := FFileName;

    { now, load the result to the second memo: }
    Memo2.Lines.Clear;
    ReadAll(Memo2.Lines);

    FileName := '';
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  BigIniFile.free;
end;

procedure TForm1.ButtonFontTestClick(Sender: TObject);
begin
  { Let user chose any font: }
  FontDialog1.Font.Assign(LabelFontDemo1.Font);
  if FontDialog1.Execute then
  begin
    LabelFontDemo1.Font.Assign(FontDialog1.Font);

    with BigIniFile do
    begin

      { load file: }
      FileName := FFileName;

      { write first label font properties to INI: }
      WriteFont('FontSample','LabelFont',LabelFontDemo1.Font);
      { read font properties from INI to second label's font: }
      ReadFont('FontSample','LabelFont',LabelFontDemo2.Font);

      { now, show the result in the second memo field: }
      Memo2.Lines.Clear;
      ReadAll(Memo2.Lines);

      FileName := '';
    end;
  end;
end;

end.
